\section{Evaluation}
\label{sec:evaluation}

We manage to fulfill all the requirements in the problem's description, thus
having an effective solution capable of solving this problem.

We meet the Confidentiality requirement since only the two communicating parties
know the secret used to cipher the client's transaction data. This is supported
by the fact the exchange is authenticated: On the bank's side, the public
parameter is signed using its private key, producing a signature that can be
promptly verified by the client who has a valid certificate for the bank from
the \ac{CA} who signed it. The client, in the other hand, uses the newly
established secret to produce an \ac{HMAC} that only the bank can verify. The
authentication mechanism during the exchange also ensures message integrity.
Freshness is ensured by recording the \textit{nonces} or the \acp{IV} sent in
every transaction message, dropping messages with repeated \textit{nonces},
which in itself enables the recycling of the \ac{IV} used to encrypt the
payload, eliminating the issue of having identical cipher texts for the same
plain text. Finally, we ensure that the transaction is non-repudiable, i.e., by
signing the message with the client's public key, there is no possible way for
the client to deny he performed the transaction.

Of course, as always in the field of security, no solution is perfect. Since
we're always using the same key for cipher transaction data, we can't ensure
\ac{PFS}. The only way to achieve \ac{PFS} would be to recycle the key being
used, either by using it as a \ac{KEK} and establishing a way of synchronizing
the keys being produced between the entities (which could result in a payload
size increase, and won't help much for it may lead to \ac{KEK} over-exposure),
or performing the exchange again, which can't be done in this context.
Furthermore, if the bank's server is breached, the whole system is compromised
due the exposure of not only all the secret keys shared with the clients, but
the bank's own private key as well, rendering its certificate useless. At that
point, the certificate should be revoked as soon as possible, the bank should
issue a warning to its clients about the disaster so the setup could be
performed again. However, the client's credentials aren't compromised since the
client's passwords are hashed using a salt as to not produce the same hash for
potentially the same password. Finally, of course, if the client's private key
is compromised (which is terribly difficult at this point, but possible) along
with the shared secret, nothing can stop an attacker from performing perfectly
"legal" transactions.